package com.docus.server.collect.basic.http.test;

import com.docus.core.util.json.JSON;
import com.docus.log.executor.TrackRetrySpringExecutor;
import com.docus.log.handler.IJobHandler;
import com.docus.log.handler.impl.MethodJobHandler;
import com.docus.server.collect.IConverter;
import com.docus.server.collect.IHttpResult;
import com.docus.server.collect.web.common.entity.TaskOriginalMessage;
import com.docus.server.collect.web.process.VisitorProcessor;
import com.docus.server.collect.web.service.CollectService;
import com.docus.server.collect.web.service.ITaskOriginalMessageService;
import com.docus.server.enums.CollectTypeEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;


/**
 * @author wen yongbin
 * @date 2023年2月25日21:56:33
 * @see CollectTypeEnum 枚举
 * @see IConverter 通用转化器
 * @see IHttpResult 通用返回结果
 * @see VisitorProcessor 通用处理器
 */

@Api(value = "TEST-用户管理接口", tags = "TEST-用户管理接口")
@Slf4j
@RestController("a")
@RequestMapping("/api/rest/user")
public class TestRestController {
    @Resource
    private CollectService collectService;
    @Resource
    private ITaskOriginalMessageService messageService;

    @ApiOperation("TEST-2")
    @GetMapping("/get2")
    public void get2() throws Exception {
        TaskOriginalMessage message = messageService.findAll().get(0);
        IJobHandler jobHandler = TrackRetrySpringExecutor.loadJobHandler(message.getRetryKey());
        String name = ((MethodJobHandler) jobHandler).getMethod().getParameterTypes()[0].getName();
        Object o = JSON.fromJSON(message.getJsonStr(), Class.forName(name));
        jobHandler.execute(o);
    }
}
