package com.docus.server.collect.web.convert;

import com.docus.core.util.DateUtil;
import com.docus.infrastructure.redis.service.IdService;
import com.docus.server.collect.web.common.entity.TaskOriginalMessage;
import com.docus.server.enums.CollectTypeEnum;
import com.docus.server.enums.StateEnum;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
public class TaskOriginalMessageConverter {
    @Resource
    private IdService idService;

    public TaskOriginalMessage toConvertTaskOriginalMessageDO(String json, String xml, CollectTypeEnum collectType, String retryKey) {
        TaskOriginalMessage taskOriginalMessage = new TaskOriginalMessage();
        taskOriginalMessage.setId(idService.getDateSeq());
        taskOriginalMessage.setName(collectType.name());
        taskOriginalMessage.setMemo(collectType.getDesc());
        taskOriginalMessage.setCollectType(collectType);
        taskOriginalMessage.setRetryKey(retryKey);
        taskOriginalMessage.setJsonStr(json);
        taskOriginalMessage.setSource(xml);
        taskOriginalMessage.setState(StateEnum.OK);
        taskOriginalMessage.setCreateTime(DateUtil.now());
        taskOriginalMessage.setUpdateTime(DateUtil.now());
        return taskOriginalMessage;
    }
}
