package com.docus.server.collect.web.job;

import com.docus.server.collect.web.common.entity.TaskOriginalMessage;
import com.docus.server.collect.web.service.ITaskOriginalMessageService;
import com.docus.server.collect.web.service.TrackRetryService;
import com.docus.server.enums.StateEnum;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;

/**
 * 重试所有被动消息 job
 */
@Component
@Slf4j
public class TrackRetryJob {

    @Resource
    private ITaskOriginalMessageService messageService;
    @Resource
    private TrackRetryService trackRetryService;

    @XxlJob("trackRetryJob")
    public void retry() throws Exception {
        List<TaskOriginalMessage> messages = messageService.findBy("state", StateEnum.FAIL);

        for (TaskOriginalMessage message : messages) {
            trackRetryService.doRetry(message);
        }
    }


}
